diff --git a/gplugin/gplugin-manager.c b/gplugin/gplugin-manager.c
--- a/gplugin/gplugin-manager.c
+++ b/gplugin/gplugin-manager.c
@@ -47,42 +47,6 @@
 
 /**
  * GPluginManagerClass:
- * @append_path: The <literal>append_path</literal> function is responsible for
- *               adding a path to the end of the list of plugin search paths.
- * @prepend_path: The <literal>prepend_path</literal> function is responsible
- *                for adding a path to the beginning of the list of plugin
- *                search paths.
- * @remove_path: The <literal>remove_path</literal> function is responsible
- *               for removing a path from the list of plugin search paths.
- * @remove_paths: The <literal>remove_paths</literal> function is responsible
- *                for clearing the list of plugin search paths.
- * @get_paths: The <literal>get_paths</literal> function is reponsible for
- *             returning a list of plugin search paths.
- * @register_loader: The <literal>register_loader</literal> function is
- *                   responsible for registering plugin loaders.
- * @unregister_loader: The <literal>unregister_loader</literal> function is
- *                     responsible for unregistering plugin loaders.
- * @get_loaders: The <literal>get_loaders</literal> function is responsible
- *               for returning a list of all registered plugin loaders.
- * @refresh: The <literal>refresh</literal> function is responsible for
- *           refreshing the state of all plugins by searching the plugin search
- *           paths.
- * @foreach: The <literal>foreach</literal> function is responsible for calling
- *           the given #GPluginManagerForeachFunc for each plugin.
- * @find_plugins: The <literal>find_plugins</literal> function is responsible
- *                for returning a list of all plugins that match the given id.
- * @find_plugins_with_state: The <literal>find_plugins_with_state</literal>
- *                           function is responsible for returning a list of
- *                           all plugins matching the given #GPluginPluginState.
- * @list_plugins: The <literal>list_plugins</literal> function is responsible
- *                for returning a list of all known plugin ids.
- * @get_plugin_dependencies: The <literal>get_plugin_dependencies</literal>
- *                           function is responsible for returning a list of
- *                           #GPluginPlugin's that the given plugin depends on.
- * @load_plugin: The <literal>load_plugin</literal> method is responsible for
- *               loading plugins.
- * @unload_plugin: The <literal>unload_plugin</literal> method is responsible
- *                 for unloading plugins.
  * @loading_plugin: Signal emitted before a plugin is loaded.
  * @loaded_plugin: Signal emitted after a plugin is loaded.
  * @load_failed: Signal emitted when a plugin fails to load.
@@ -92,6 +56,7 @@
  *
  * Virtual function table for #GPluginManager.
  */
+
 /******************************************************************************
  * Enums
  *****************************************************************************/
@@ -126,7 +91,7 @@
 /******************************************************************************
  * Globals
  *****************************************************************************/
-GPluginManager *instance = NULL;
+GPluginManager *default_manager = NULL;
 static guint signals[N_SIGNALS] = {
 	0,
 };
@@ -249,19 +214,344 @@
 	return r;
 }
 
+static gboolean
+gplugin_manager_load_dependencies(
+	GPluginManager *manager,
+	GPluginPlugin *plugin,
+	GPluginPluginInfo *info,
+	GError **error)
+{
+	GSList *dependencies = NULL, *l = NULL;
+	GError *ourerror = NULL;
+	gboolean all_loaded = TRUE;
+
+	dependencies =
+		gplugin_manager_get_plugin_dependencies(manager, plugin, &ourerror);
+	if(ourerror != NULL) {
+		g_propagate_error(error, ourerror);
+
+		return FALSE;
+	}
+
+	for(l = dependencies; l != NULL; l = l->next) {
+		GPluginPlugin *dependency = GPLUGIN_PLUGIN(l->data);
+		gboolean loaded = FALSE;
+
+		loaded = gplugin_manager_load_plugin(manager, dependency, &ourerror);
+
+		if(!loaded || ourerror != NULL) {
+			if(ourerror != NULL) {
+				g_propagate_error(error, ourerror);
+			}
+
+			all_loaded = FALSE;
+			break;
+		}
+	}
+
+	g_slist_free_full(dependencies, g_object_unref);
+
+	return all_loaded;
+}
+
 /******************************************************************************
  * Manager implementation
  *****************************************************************************/
+static gboolean
+gplugin_manager_loading_cb(
+	G_GNUC_UNUSED GPluginManager *manager,
+	G_GNUC_UNUSED GPluginPlugin *plugin,
+	G_GNUC_UNUSED GError **error)
+{
+	return TRUE;
+}
+
+static gboolean
+gplugin_manager_unloading_cb(
+	G_GNUC_UNUSED GPluginManager *manager,
+	G_GNUC_UNUSED GPluginPlugin *plugin,
+	G_GNUC_UNUSED GError **error)
+{
+	return TRUE;
+}
+
+/******************************************************************************
+ * GObject Implementation
+ *****************************************************************************/
 static void
-gplugin_manager_real_append_path(GPluginManager *manager, const gchar *path)
+gplugin_manager_finalize(GObject *obj)
+{
+	GPluginManager *manager = GPLUGIN_MANAGER(obj);
+	GPluginManagerPrivate *priv = gplugin_manager_get_instance_private(manager);
+
+	g_queue_free_full(priv->paths, g_free);
+	priv->paths = NULL;
+
+	/* unload all of the loaded plugins */
+	g_hash_table_foreach(
+		priv->plugins,
+		gplugin_manager_foreach_unload_plugin,
+		NULL);
+
+	/* free all the data in the plugins hash table and destroy it */
+	g_hash_table_foreach_remove(
+		priv->plugins,
+		gplugin_manager_remove_list_value,
+		NULL);
+	g_clear_pointer(&priv->plugins, g_hash_table_destroy);
+
+	/* destroy the filename view */
+	g_clear_pointer(&priv->plugins_filename_view, g_hash_table_destroy);
+
+	/* clean up our list of loaders */
+	g_slist_free_full(priv->loaders, g_object_unref);
+	priv->loaders = NULL;
+
+	/* free all the data in the loaders hash table and destroy it */
+	g_hash_table_foreach_remove(
+		priv->loaders_by_extension,
+		gplugin_manager_remove_list_value,
+		NULL);
+	g_clear_pointer(&priv->loaders_by_extension, g_hash_table_destroy);
+
+	/* call the base class's destructor */
+	G_OBJECT_CLASS(gplugin_manager_parent_class)->finalize(obj);
+}
+
+static void
+gplugin_manager_class_init(GPluginManagerClass *klass)
+{
+	GObjectClass *obj_class = G_OBJECT_CLASS(klass);
+	GPluginManagerClass *manager_class = GPLUGIN_MANAGER_CLASS(klass);
+
+	obj_class->finalize = gplugin_manager_finalize;
+
+	manager_class->loading_plugin = gplugin_manager_loading_cb;
+	manager_class->unloading_plugin = gplugin_manager_unloading_cb;
+
+	/* signals */
+
+	/**
+	 * GPluginManager::loading-plugin:
+	 * @manager: The #GPluginManager instance.
+	 * @plugin: The #GPluginPlugin that's about to be loaded.
+	 * @error: Return address for a #GError.
+	 *
+	 * Emitted before @plugin is loaded.
+	 *
+	 * Return FALSE to stop loading
+	 */
+	signals[SIG_LOADING] = g_signal_new(
+		"loading-plugin",
+		G_OBJECT_CLASS_TYPE(manager_class),
+		G_SIGNAL_RUN_LAST,
+		G_STRUCT_OFFSET(GPluginManagerClass, loading_plugin),
+		gplugin_boolean_accumulator,
+		NULL,
+		NULL,
+		G_TYPE_BOOLEAN,
+		2,
+		G_TYPE_OBJECT,
+		G_TYPE_POINTER);
+
+	/**
+	 * GPluginManager::loaded-plugin:
+	 * @manager: the #gpluginpluginmanager instance.
+	 * @plugin: the #gpluginplugin that's about to be loaded.
+	 *
+	 * emitted after a plugin is loaded.
+	 */
+	signals[SIG_LOADED] = g_signal_new(
+		"loaded-plugin",
+		G_OBJECT_CLASS_TYPE(manager_class),
+		G_SIGNAL_RUN_LAST,
+		G_STRUCT_OFFSET(GPluginManagerClass, loaded_plugin),
+		NULL,
+		NULL,
+		NULL,
+		G_TYPE_NONE,
+		1,
+		G_TYPE_OBJECT);
+
+	/**
+	 * GPluginManager::load-plugin-failed:
+	 * @manager: The #GPluginManager instance.
+	 * @plugin: The #GPluginPlugin that failed to load.
+	 *
+	 * emitted after a plugin fails to load.
+	 */
+	signals[SIG_LOAD_FAILED] = g_signal_new(
+		"load-plugin-failed",
+		G_OBJECT_CLASS_TYPE(manager_class),
+		G_SIGNAL_RUN_LAST,
+		G_STRUCT_OFFSET(GPluginManagerClass, load_failed),
+		NULL,
+		NULL,
+		NULL,
+		G_TYPE_NONE,
+		1,
+		G_TYPE_OBJECT);
+
+	/**
+	 * GPluginManager::unloading-plugin
+	 * @manager: the #GPluginManager instance.
+	 * @plugin: the #GPluginPlugin that's about to be unloaded.
+	 * @error: Return address for a #GError.
+	 *
+	 * emitted before a plugin is unloaded.
+	 *
+	 * Return FALSE to stop unloading
+	 */
+	signals[SIG_UNLOADING] = g_signal_new(
+		"unloading-plugin",
+		G_OBJECT_CLASS_TYPE(manager_class),
+		G_SIGNAL_RUN_LAST,
+		G_STRUCT_OFFSET(GPluginManagerClass, unloading_plugin),
+		gplugin_boolean_accumulator,
+		NULL,
+		NULL,
+		G_TYPE_BOOLEAN,
+		2,
+		G_TYPE_OBJECT,
+		G_TYPE_POINTER);
+
+	/**
+	 * GPluginManager::unloaded-plugin:
+	 * @manager: the #gpluginpluginmanager instance.
+	 * @plugin: the #gpluginplugin that's about to be loaded.
+	 *
+	 * emitted after a plugin is successfully unloaded.
+	 */
+	signals[SIG_UNLOADED] = g_signal_new(
+		"unloaded-plugin",
+		G_OBJECT_CLASS_TYPE(manager_class),
+		G_SIGNAL_RUN_LAST,
+		G_STRUCT_OFFSET(GPluginManagerClass, unloaded_plugin),
+		NULL,
+		NULL,
+		NULL,
+		G_TYPE_NONE,
+		1,
+		G_TYPE_OBJECT);
+
+	/**
+	 * GPluginManager::unload-plugin-failed:
+	 * @manager: The #GPluginManager instance.
+	 * @plugin: The #GPluginPlugin instance that failed to unload.
+	 * @error: A #GError instance.
+	 *
+	 * Emitted when @manager was asked to unload @plugin, but @plugin returned
+	 * %FALSE when its unload function was called.
+	 */
+	signals[SIG_UNLOAD_FAILED] = g_signal_new(
+		"unload-plugin-failed",
+		G_OBJECT_CLASS_TYPE(manager_class),
+		G_SIGNAL_RUN_LAST,
+		G_STRUCT_OFFSET(GPluginManagerClass, unload_plugin_failed),
+		NULL,
+		NULL,
+		NULL,
+		G_TYPE_NONE,
+		1,
+		G_TYPE_OBJECT);
+}
+
+static void
+gplugin_manager_init(GPluginManager *manager)
+{
+	GPluginManagerPrivate *priv = gplugin_manager_get_instance_private(manager);
+
+	priv->paths = g_queue_new();
+
+	/* the plugins hashtable is keyed on a plugin id and holds a GSList of all
+	 * plugins that share that id.
+	 */
+	priv->plugins =
+		g_hash_table_new_full(g_str_hash, g_str_equal, g_free, NULL);
+
+	/* the filename view is hash table keyed on the filename of the plugin with
+	 * a value of the plugin itself.
+	 */
+	priv->plugins_filename_view =
+		g_hash_table_new_full(g_str_hash, g_str_equal, g_free, g_object_unref);
+
+	/* The loaders_by_extension hash table is keyed on the supported extensions
+	 * of the loader.  Which means that a loader that supports multiple
+	 * extensions will be in the table multiple times.
+	 *
+	 * We deal with collisions by using a GSList for the value which will hold
+	 * references to instances of the actual loaders.
+	 *
+	 * Storing this in this method allows us to quickly figure out which loader
+	 * to use by the filename and helps us to avoid iterating the loaders table
+	 * again and again.
+	 */
+	priv->loaders_by_extension = g_hash_table_new_full(
+		gplugin_manager_str_hash,
+		g_str_equal,
+		g_free,
+		NULL);
+}
+
+/******************************************************************************
+ * Private API
+ *****************************************************************************/
+void
+gplugin_manager_private_init(gboolean register_native_loader)
+{
+	GError *error = NULL;
+
+	if(GPLUGIN_IS_MANAGER(default_manager)) {
+		return;
+	}
+
+	default_manager = g_object_new(GPLUGIN_TYPE_MANAGER, NULL);
+
+	if(register_native_loader) {
+		if(!gplugin_manager_register_loader(
+			   default_manager,
+			   GPLUGIN_TYPE_NATIVE_LOADER,
+			   &error)) {
+			if(error != NULL) {
+				g_error("failed to register loader: %s", error->message);
+				g_error_free(error);
+			} else {
+				g_error("failed to register loader: unknown failure");
+			}
+		}
+	}
+
+	dependency_regex = g_regex_new(dependency_pattern, 0, 0, NULL);
+}
+
+void
+gplugin_manager_private_uninit(void)
+{
+	g_regex_unref(dependency_regex);
+
+	g_clear_object(&default_manager);
+}
+
+/******************************************************************************
+ * API
+ *****************************************************************************/
+
+/**
+ * gplugin_manager_append_path:
+ * @manager: The #GPluginManager instance.
+ * @path: A path to add to the end of the plugin search paths.
+ *
+ * Adds @path to the end of the list of paths to search for plugins.
+ */
+void
+gplugin_manager_append_path(GPluginManager *manager, const gchar *path)
 {
 	GPluginManagerPrivate *priv = NULL;
 	GList *l = NULL;
 	gchar *normalized = NULL;
 
-	if(!path) {
-		return;
-	}
+	g_return_if_fail(GPLUGIN_IS_MANAGER(manager));
+	g_return_if_fail(path != NULL);
 
 	normalized = gplugin_manager_normalize_path(path);
 
@@ -278,16 +568,22 @@
 	}
 }
 
-static void
-gplugin_manager_real_prepend_path(GPluginManager *manager, const gchar *path)
+/**
+ * gplugin_manager_prepend_path:
+ * @manager: The #GPluginManager instance.
+ * @path: A path to add to the beginning of the plugin search paths.
+ *
+ * Adds @path to the beginning of the list of paths to search for plugins.
+ */
+void
+gplugin_manager_prepend_path(GPluginManager *manager, const gchar *path)
 {
 	GPluginManagerPrivate *priv = NULL;
 	GList *l = NULL;
 	gchar *normalized = NULL;
 
-	if(!path) {
-		return;
-	}
+	g_return_if_fail(GPLUGIN_IS_MANAGER(manager));
+	g_return_if_fail(path != NULL);
 
 	normalized = gplugin_manager_normalize_path(path);
 
@@ -304,13 +600,21 @@
 	}
 }
 
-static void
-gplugin_manager_real_remove_path(GPluginManager *manager, const gchar *path)
+/**
+ * gplugin_manager_remove_path:
+ * @manager: The #GPluginManager instance.
+ * @path: A path to remove from the plugin search paths.
+ *
+ * Removes @path from the list of paths to search for plugins.
+ */
+void
+gplugin_manager_remove_path(GPluginManager *manager, const gchar *path)
 {
 	GPluginManagerPrivate *priv = NULL;
 	GList *l = NULL;
 	gchar *normalized = NULL;
 
+	g_return_if_fail(GPLUGIN_IS_MANAGER(manager));
 	g_return_if_fail(path != NULL);
 
 	normalized = gplugin_manager_normalize_path(path);
@@ -329,26 +633,114 @@
 	g_free(normalized);
 }
 
-static void
-gplugin_manager_real_remove_paths(GPluginManager *manager)
+/**
+ * gplugin_manager_remove_paths:
+ * @manager: The #GPluginManager instance.
+ *
+ * Clears all paths that are set to search for plugins.
+ */
+void
+gplugin_manager_remove_paths(GPluginManager *manager)
 {
-	GPluginManagerPrivate *priv = gplugin_manager_get_instance_private(manager);
+	GPluginManagerPrivate *priv = NULL;
+
+	g_return_if_fail(GPLUGIN_IS_MANAGER(manager));
+
+	priv = gplugin_manager_get_instance_private(manager);
 
 	/* g_queue_clear_full was added in 2.60 but we require 2.40 */
 	g_queue_foreach(priv->paths, (GFunc)g_free, NULL);
 	g_queue_clear(priv->paths);
 }
 
-static GList *
-gplugin_manager_real_get_paths(GPluginManager *manager)
+/**
+ * gplugin_manager_add_default_paths:
+ * @manager: The #GPluginManager instance.
+ *
+ * Adds the path that GPlugin was installed to to the plugin search path, as
+ * well as `${XDG_CONFIG_HOME}/gplugin` so users can install additional loaders
+ * themselves.
+ */
+void
+gplugin_manager_add_default_paths(GPluginManager *manager)
 {
-	GPluginManagerPrivate *priv = gplugin_manager_get_instance_private(manager);
+	gchar *path;
+
+	g_return_if_fail(GPLUGIN_IS_MANAGER(manager));
+
+	path = g_build_filename(PREFIX, LIBDIR, "gplugin", NULL);
+	gplugin_manager_prepend_path(manager, path);
+	g_free(path);
+
+	path = g_build_filename(g_get_user_config_dir(), "gplugin", NULL);
+	gplugin_manager_prepend_path(manager, path);
+	g_free(path);
+}
+
+/**
+ * gplugin_manager_add_app_paths:
+ * @manager: The #GPluginManager instance.
+ * @prefix: The installation prefix for the application.
+ * @appname: The name of the application whose paths to add.
+ *
+ * Adds the application installation path for @appname.  This will add
+ * `@prefix/@appname/plugins` to the list as well as
+ * `${XDG_CONFIG_HOME}/@appname/plugins`.
+ */
+void
+gplugin_manager_add_app_paths(
+	GPluginManager *manager,
+	const gchar *prefix,
+	const gchar *appname)
+{
+	gchar *path;
+
+	g_return_if_fail(GPLUGIN_IS_MANAGER(manager));
+	g_return_if_fail(appname != NULL);
+
+	path = g_build_filename(prefix, LIBDIR, appname, NULL);
+	gplugin_manager_prepend_path(manager, path);
+	g_free(path);
+
+	path = g_build_filename(g_get_user_config_dir(), appname, "plugins", NULL);
+	gplugin_manager_prepend_path(manager, path);
+	g_free(path);
+}
+
+/**
+ * gplugin_manager_get_paths:
+ * @manager: The #GPluginManager instance.
+ *
+ * Gets the list of paths which will be searched for plugins.
+ *
+ * Returns: (element-type utf8) (transfer none): The list of paths which will
+ *          be searched for plugins.
+ */
+GList *
+gplugin_manager_get_paths(GPluginManager *manager)
+{
+	GPluginManagerPrivate *priv = NULL;
+
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), NULL);
+
+	priv = gplugin_manager_get_instance_private(manager);
 
 	return priv->paths->head;
 }
 
-static gboolean
-gplugin_manager_real_register_loader(
+/**
+ * gplugin_manager_register_loader:
+ * @manager: The #GPluginManager instance.
+ * @type: #GType of a #GPluginLoader.
+ * @error: (out) (nullable): The return address for a #GError.
+ *
+ * Registers @type as an available loader.
+ *
+ * Returns: %TRUE if the loader was successfully register, %FALSE otherwise
+ *          with @error set.
+ */
+gboolean
+gplugin_manager_register_loader(
 	GPluginManager *manager,
 	GType type,
 	GError **error)
@@ -357,6 +749,7 @@
 	GPluginLoader *loader = NULL;
 	GSList *l = NULL, *exts = NULL;
 
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), FALSE);
 	g_return_val_if_fail(g_type_is_a(type, GPLUGIN_TYPE_LOADER), FALSE);
 
 	loader = gplugin_manager_find_loader_by_type(manager, type);
@@ -429,8 +822,19 @@
 	return TRUE;
 }
 
-static gboolean
-gplugin_manager_real_unregister_loader(
+/**
+ * gplugin_manager_unregister_loader:
+ * @manager: The #GPluginManager instance.
+ * @type: #GType of a #GPluginLoader.
+ * @error: (out) (nullable): The return address for a #GError.
+ *
+ * Unregisters @type as an available loader.
+ *
+ * Returns: %TRUE if the loader was successfully unregistered, %FALSE
+ *          otherwise with @error set.
+ */
+gboolean
+gplugin_manager_unregister_loader(
 	GPluginManager *manager,
 	GType type,
 	GError **error)
@@ -439,6 +843,7 @@
 	GPluginLoader *loader = NULL;
 	GSList *l = NULL, *exts = NULL;
 
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), FALSE);
 	g_return_val_if_fail(g_type_is_a(type, GPLUGIN_TYPE_LOADER), FALSE);
 
 	loader = gplugin_manager_find_loader_by_type(manager, type);
@@ -501,16 +906,35 @@
 	return TRUE;
 }
 
-static GSList *
-gplugin_manager_real_get_loaders(GPluginManager *manager)
+/**
+ * gplugin_manager_get_loaders:
+ * @manager: The #GPluginManager instance.
+ *
+ * Returns a list of all registered #GPluginLoader's.
+ *
+ * Returns: (element-type GPlugin.Loader) (transfer full): Returns a list of all
+ *          registered loaders.
+ */
+GSList *
+gplugin_manager_get_loaders(GPluginManager *manager)
 {
-	GPluginManagerPrivate *priv = gplugin_manager_get_instance_private(manager);
+	GPluginManagerPrivate *priv = NULL;
+
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), FALSE);
+
+	priv = gplugin_manager_get_instance_private(manager);
 
 	return g_slist_copy_deep(priv->loaders, (GCopyFunc)g_object_ref, NULL);
 }
 
-static void
-gplugin_manager_real_refresh(GPluginManager *manager)
+/**
+ * gplugin_manager_refresh:
+ * @manager: The #GPluginManager instance.
+ *
+ * Forces a refresh of all plugins found in the search paths.
+ */
+void
+gplugin_manager_refresh(GPluginManager *manager)
 {
 	GPluginManagerPrivate *priv = NULL;
 	GNode *root = NULL;
@@ -518,6 +942,8 @@
 	gchar *error_message = NULL;
 	guint errors = 0;
 
+	g_return_if_fail(GPLUGIN_IS_MANAGER(manager));
+
 	priv = gplugin_manager_get_instance_private(manager);
 
 	/* build a tree of all possible plugins */
@@ -739,8 +1165,16 @@
 	gplugin_file_tree_free(root);
 }
 
-static void
-gplugin_manager_real_foreach(
+/**
+ * gplugin_manager_foreach:
+ * @manager: The #GPluginManager instance.
+ * @func: (scope call): The #GPluginManagerForeachFunc to call.
+ * @data: User data to pass to func.
+ *
+ * Calls @func for each plugin that is known.
+ */
+void
+gplugin_manager_foreach(
 	GPluginManager *manager,
 	GPluginManagerForeachFunc func,
 	gpointer data)
@@ -749,6 +1183,9 @@
 	GHashTableIter iter;
 	gpointer id = NULL, plugins = NULL;
 
+	g_return_if_fail(GPLUGIN_IS_MANAGER(manager));
+	g_return_if_fail(func != NULL);
+
 	priv = gplugin_manager_get_instance_private(manager);
 
 	g_hash_table_iter_init(&iter, priv->plugins);
@@ -757,12 +1194,25 @@
 	}
 }
 
-static GSList *
-gplugin_manager_real_find_plugins(GPluginManager *manager, const gchar *id)
+/**
+ * gplugin_manager_find_plugins:
+ * @manager: The #GPluginManager instance.
+ * @id: id string of the plugin to find.
+ *
+ * Finds all plugins matching @id.
+ *
+ * Returns: (element-type GPlugin.Plugin) (transfer full): A #GSList of
+ *          referenced #GPluginPlugin's matching @id.  Call
+ *          g_slist_free_full() with a `DestroyNotify` of g_object_unref() on
+ *          the returned value when you're done with it.
+ */
+GSList *
+gplugin_manager_find_plugins(GPluginManager *manager, const gchar *id)
 {
 	GPluginManagerPrivate *priv = NULL;
 	GSList *plugins_list = NULL, *l;
 
+	g_return_val_if_fail(GPLUGIN_IS_MANAGER(manager), NULL);
 	g_return_val_if_fail(id != NULL, NULL);
 
 	priv = gplugin_manager_get_instance_private(manager);
